include:
  local: .gitlab/ci_templates/git-push.gitlab-ci.yaml

stages:
  - build
  - deploy

default:
  before_script:
    - export IMAGE_REF=${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHA}
  tags:
    - gxfs-fr

workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
    - if: $CI_COMMIT_BRANCH && $CI_OPEN_MERGE_REQUESTS # avoid duplicate pipelines
      when: never
    - if: $CI_COMMIT_BRANCH
    - changes:
        - deployment/generated_manifests/**/*
      when: never

build:
  stage: "build"
  image:
    name: "gcr.io/kaniko-project/executor:v1.23.1-debug"
    entrypoint: [""]
  tags:
    - gxfs-fr
  script:
    - "/kaniko/executor --context ${CI_PROJECT_DIR} --dockerfile ${CI_PROJECT_DIR}/Dockerfile --destination ${IMAGE_REF}"

deploy:demo:
  stage: "deploy"
  tags:
    - gxfs-fr
  image:
    name: nixos/nix:2.22.1
    entrypoint: [""]
  variables:
    PACKAGE_PATH: deployment/packages/overlays/demo23-participants
  script:
    - nix-env -iA nixpkgs.kustomize nixpkgs.kubectl
    - kubectl config get-contexts
    - kubectl config use-context gaia-x/data-infrastructure-federation-services/deployment-scenario/infrastructure/k8s-deployment:demo23
    - kubectl get pods -n gitlab-agent-dev
    # Update the kustomize overlay with the image reference.
    - cd ${PACKAGE_PATH}
    - kustomize edit set image image-name=${IMAGE_REF}
    # Generate the definitive kubernetes manifests using the kustomize overlay
    - kubectl apply -k . --timeout=300s --wait=true
  rules:
    - if: $CI_COMMIT_BRANCH == 'main'

deploy:legacy:
  stage: "deploy"
  image:
    name: nixos/nix:2.22.1
    entrypoint: [""]
  variables:
    PACKAGE_PATH: deployment/packages/overlays/demo22-participants
  script:
    - nix-env -iA nixpkgs.kustomize nixpkgs.kubectl
    - kubectl config get-contexts
    - kubectl config use-context gaia-x/data-infrastructure-federation-services/deployment-scenario/infrastructure/k8s-deployment:default
    - kubectl get pods -n gitlab-agent-dev
    # Update the kustomize overlay with the image reference.
    - cd ${PACKAGE_PATH}
    - kustomize edit set image image-name=${IMAGE_REF}
    # Generate the definitive kubernetes manifests using the kustomize overlay
    - kubectl apply -k . --timeout=300s --wait=true
  rules:
    - if: $CI_COMMIT_BRANCH == 'demo2022'